#include "Matrix.h"

CMatrix::CMatrix(void)
{
	size = 0;
	data = NULL;
}

CMatrix::~CMatrix(void)
{
	for ( int row = 0 ; row < size ; row++ )
	{
		delete[] data[row];
	}
	delete[] data;
	data = NULL;
}

void CMatrix::setSize(int size)
{
	this->size = size;
	data = new float*[size];
	for ( int row = 0 ; row < size ; row++ )
	{
		data[row] = new float[size];
	}
}

float& CMatrix::operator()(int row, int column)
{
	// TODO: check validity of row/column
	return data[row][column];
}

void CMatrix::add(CMatrix& matrix)
{
	for ( int row = 0 ; row < size ; row++ )
	{
		for ( int col = 0 ; col < size ; col++ )
		{
			data[row][col] += matrix.data[row][col];
			// or: data[row][col] += matrix(row, col);
		}
	}
}

void CMatrix::operator+=(CMatrix& matrix)
{
	add(matrix);
}

ostream& operator<<(ostream& s, CMatrix& matrix)
{
	s << "Matrix: Size=" << matrix.size << endl;
	for ( int row = 0 ; row < matrix.size ; row++ )
	{
		for ( int col = 0 ; col < matrix.size ; col++ )
		{
			s << matrix(row, col) << "\t";
		}
		s << endl;
	}
	return s;
}